define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");

	var Model = function() {
		this.callParent();
		this.xstate = "-1";
	};

	Model.prototype.newBtnClick = function(event) {
		// 判断月报是否开启
		var ybqj = this.comp("ybqj");
		ybqj.refreshData();
		if (ybqj.count() != 1) {
			throw justep.Error.create("当前时间不能填报");
		}
		// 获取期间年、月是时间
		var year = ybqj.getValue("fYBQJ_ND");
		var month = ybqj.getValue("fYBQJ_YD");

		var mainData = this.comp("mainData");
		mainData.newData();
		mainData.setValue("fYBTBZB_ND", year);
		mainData.setValue("fYBTBZB_YD", month);
		this.goTotab();
	};

	Model.prototype.goTotab = function() {
		var tabs = this.comp("tabs");
		tabs.setActiveTab("nav-detail");
	};

	Model.prototype.orderTablesRowDblClick = function(event) {
		var mainData = this.comp("mainData");
		mainData.to(event.bindingContext.$object);
		this.goTotab();
	};

	Model.prototype.DataSaveCommit = function(event) {
		if (this.xstate == "-1") {
			justep.Util.hint("保存成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
		} else if (this.xstate == "1") {
			justep.Util.hint("提交成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
			this.xstate = "-1";
		} else if (this.xstate == "3" || this.xstate == "5") {
			justep.Util.hint("审批成功！", {
				type : 'success',
				parent : this.getRootNode()
			});
			this.xstate = "-1";
		} else if (this.xstate == "2" || this.xstate == "4") {
			// TODO:驳回暂不提示
			this.xstate = "-1";
		}
		;
	};

	// 新签约 详细单元格渲染 mengjie 2019-12-13
	Model.prototype.detailGridCellRender = function(event) {
		if ((event.colName == "fYBTBMX_DHXM" || event.colName == "fYBTBMX_GSZC" || event.colName == "fYBTBMX_SFRK")
				&& event.colVal != "") {
			var value = event.colVal == 1 ? "是" : "否";
			// event.html = "<div>" + value + "</div>";
			event.html = value;
		}
	};
	// 在建 详细单元格渲染 mengjie 2019-12-13
	Model.prototype.zjGridCellRender = function(event) {
		if ((event.colName == "fYBTBMX_DHXM" || event.colName == "fYBTBMX_GSZC")
				&& event.colVal != "") {
			var value = event.colVal == 1 ? "是" : "否";
			// event.html = "<div>" + value + "</div>";
			event.html = value;
		}
	};
	// 竣工 详细单元格渲染 mengjie 2019-12-13
	Model.prototype.jgGridCellRender = function(event) {
		if ((event.colName == "fYBTBMX_DHXM" || event.colName == "fYBTBMX_GSZC")
				&& event.colVal != "") {
			var value = event.colVal == 1 ? "是" : "否";
			// event.html = "<div>" + value + "</div>";
			event.html = value;
		}
	};

	// 实际完成投资 详细单元格渲染 mengjie 2019-12-13
	Model.prototype.sjwcGridCellRender = function(event) {
		if ((event.colName == "fYBTBMX_DHXM" || event.colName == "fYBTBMX_GSZC")
				&& event.colVal != "") {
			var value = event.colVal == 1 ? "是" : "否";
			// event.html = "<div>" + value + "</div>";
			event.html = value;
		}
	};

	// 列表单元格渲染 mengjie 2019-12-16
	Model.prototype.mainTablesCellRender = function(event) {
		if (event.colName == "fYBTBZB_SHZT" && event.colVal != "") {
			// shzt data必须在maindata之,否则渲染不成功,找不到对应值
			var rows = this.comp("shzt").find([ 'code' ], event.colVal);
			var value = rows[0].val("name");
			event.html = value;
		}
	};

	// 引入本月数据 mengjie 2019-12-23
	Model.prototype.leadtonClick = function(event) {
		// 判断本单位及单位以下项目是否全部上报
		var allReported = this.comp("AllReported");
		allReported.refreshData();
		if (allReported.getCount() > 0) {
			alert("有项目没有上报,不能引入数据");
			return false;
		}
		var mainData = this.comp("mainData");
		var nd = mainData.val("fYBTBZB_ND");
		var yd = mainData.val("fYBTBZB_YD");
		var org = this.getContext().getCurrentOgnFID();
		var xmjz = this.comp("xmjz");
		// 新签约
		var filter = "YQHZ_XMJZ.fXMJZ_ND='"+ nd+ "' and YQHZ_XMJZ.fXMJZ_YD='"+ yd
		+ "' and YQHZ_XMJZ.fXMJZ_SZZZFID like'%"+ org+ "%' and YQHZ_XMJZ.fXMJZ_XMZT in('0','1')";
		xmjz.setFilter("filter", filter);
		xmjz.refreshData();
		// 循环赋值
		var detailData = this.comp("detailData");
		detailData.clear();// 赋值前清空data
		xmjz.each(function(param) {
			detailData.newData();// 新增行
			var row = param.row;
			detailData.setValue("fXMXX_XMMC", row.val("fXMXX_XMMC"));// 项目名称
			detailData.setValue("fYBTBMX_XMID", row.val("fXMJZ_XMID"));// 项目ID
			detailData.setValue("fXMXX_LSGX", row.val("LSGX"));// 隶属关系
			detailData.setValue("fXMXX_TZGM", row.val("fXMXX_TZGM"));// 投资规模
			detailData.setValue("fHZQY_QYMC", row.val("fXMXX_XMMC"));// 甲方
			detailData.setValue("fXMXX_YF1", row.val("fXMXX_YF1"));// 乙方
			detailData.setValue("fXMXX_QYRQ", row.val("fXMXX_QYRQ"));// 签约日期
			detailData.setValue("fXMXX_JHKSRQ", row.val("fXMXX_JHKSRQ"));// 计划开始日期
			detailData.setValue("fYBTBMX_DHXM", row.val("fXMJZ_DHXM"));// 大会项目
			detailData.setValue("fYBTBMX_GSZC", row.val("fXMJZ_GSZCDJQK"));// 工商注册
			detailData.setValue("fYBTBMX_ZCQYMC", row.val("fXMJZ_ZCQYMC"));// 注册企业
			detailData.setValue("fYBTBMX_XMJZ", row.val("fXMJZ_XMJZ"));// 项目进展
			detailData.setValue("fYBTBMX_XYXDDWT", row.val("fXMJZ_XYXDDWT"));// 需要协调的问题
			detailData.setValue("fYBTBMX_XMZT", row.val("fXMJZ_XMZT"));// 项目状态
			detailData.setValue("fYBTBMX_YQBS", "0");// 页签标识
		});

		// 在建
		filter = "YQHZ_XMJZ.fXMJZ_ND='"
				+ nd
				+ "' and YQHZ_XMJZ.fXMJZ_YD='"
				+ yd
				+ "' and YQHZ_XMJZ.fXMJZ_SZZZFID like '%"
				+ org+ "%'  and YQHZ_XMJZ.fXMJZ_XMZT ='2'";
		xmjz.setFilter("filter", filter);
		xmjz.refreshData();
		// 循环赋值
		var zjData = this.comp("zjData");
		zjData.clear();// 赋值前清空data
		xmjz.each(function(param) {
			zjData.newData();// 新增行
			var row = param.row;
			zjData.setValue("fXMXX_XMMC", row.val("fXMXX_XMMC"));// 项目名称
			zjData.setValue("fYBTBMX_XMID", row.val("fXMJZ_XMID"));// 项目ID
			zjData.setValue("fXMXX_LSGX", row.val("LSGX"));// 隶属关系
			zjData.setValue("fXMXX_TZGM", row.val("fXMXX_TZGM"));// 投资规模
			zjData.setValue("fHZQY_QYMC", row.val("fXMXX_XMMC"));// 甲方
			zjData.setValue("fXMXX_YF1", row.val("fXMXX_YF1"));// 乙方
			zjData.setValue("fYBTBMX_DHXM", row.val("fXMJZ_DHXM"));// 大会项目
			zjData.setValue("fYBTBMX_GSZC", row.val("fXMJZ_GSZCDJQK"));// 工商注册
			zjData.setValue("fYBTBMX_ZCQYMC", row.val("fXMJZ_ZCQYMC"));// 注册企业
			zjData.setValue("fYBTBMX_XMJZ", row.val("fXMJZ_XMJZ"));// 项目进展
			zjData.setValue("fYBTBMX_XYXDDWT", row.val("fXMJZ_XYXDDWT"));// 需要协调的问题

			zjData.setValue("fYBTBMX_KGRQ", row.val("fXMJZ_KGRQ"));// 开工日期
			zjData.setValue("fYBTBMX_BYTZE", row.val("fXMJZ_BYWCTZ"));// 本月投资额
			zjData.setValue("fYBTBMX_JZSYLJWCE", row.val("fXMJZ_SYLJWCE"));// 截至上月累计完成
			zjData.setValue("fYBTBMX_JZMQLJWCE", row.val("fXMJZ_MQLJWCE"));// 截至目前累计完成
			zjData.setValue("fYBTBMX_YJNNWCLJTZE", row.val("fXMJZ_YJNNWCE"));// 预计年内完成
			zjData.setValue("fYBTBMX_XMZT", row.val("fXMJZ_XMZT"));// 项目状态
			zjData.setValue("fYBTBMX_YQBS", "2");// 页签标识
		});

		// 竣工
		filter = "YQHZ_XMJZ.fXMJZ_ND='"
				+ nd
				+ "' and YQHZ_XMJZ.fXMJZ_YD='"
				+ yd
				+ "' and YQHZ_XMJZ.fXMJZ_SZZZFID like '%"
				+ org+ "%'  and YQHZ_XMJZ.fXMJZ_XMZT ='3'";
		xmjz.setFilter("filter", filter);
		xmjz.refreshData();
		// 循环赋值
		var jgData = this.comp("jgData");
		jgData.clear();// 赋值前清空data
		xmjz.each(function(param) {
			jgData.newData();// 新增行
			var row = param.row;
			jgData.setValue("fXMXX_XMMC", row.val("fXMXX_XMMC"));// 项目名称
			jgData.setValue("fYBTBMX_XMID", row.val("fXMJZ_XMID"));// 项目ID
			jgData.setValue("fXMXX_LSGX", row.val("LSGX"));// 隶属关系
			jgData.setValue("fXMXX_TZGM", row.val("fXMXX_TZGM"));// 投资规模
			jgData.setValue("fHZQY_QYMC", row.val("fXMXX_XMMC"));// 甲方
			jgData.setValue("fXMXX_YF1", row.val("fXMXX_YF1"));// 乙方
			jgData.setValue("fYBTBMX_DHXM", row.val("fXMJZ_DHXM"));// 大会项目
			jgData.setValue("fYBTBMX_GSZC", row.val("fXMJZ_GSZCDJQK"));// 工商注册
			jgData.setValue("fYBTBMX_ZCQYMC", row.val("fXMJZ_ZCQYMC"));// 注册企业
			jgData.setValue("fYBTBMX_XMJZ", row.val("fXMJZ_XMJZ"));// 项目进展
			jgData.setValue("fYBTBMX_XYXDDWT", row.val("fXMJZ_XYXDDWT"));// 需要协调的问题
			jgData.setValue("fYBTBMX_BYTZE", row.val("fXMJZ_BYWCTZ"));// 本月投资额
			jgData.setValue("fYBTBMX_JZSYLJWCE", row.val("fXMJZ_SYLJWCE"));// 截至上月累计完成
			jgData.setValue("fYBTBMX_JZMQLJWCE", row.val("fXMJZ_MQLJWCE"));// 截至目前累计完成
			jgData.setValue("fYBTBMX_YJNNWCLJTZE", row.val("fXMJZ_YJNNWCE"));// 预计年内完成
			jgData.setValue("fYBTBMX_WGRQ", row.val("fXMJZ_WGRQ"));// 完工日期
			jgData.setValue("fYBTBMX_XZYYSR", row.val("fXMJZ_XZYYSR"));// 新增收入
			jgData.setValue("fYBTBMX_XZLR", row.val("fXMJZ_XZLR"));// 新增利润
			jgData.setValue("fYBTBMX_XZSS", row.val("fXMJZ_XZSS"));// 新增税收
			jgData.setValue("fYBTBMX_XZJYRY", row.val("fXMJZ_XZJYRY"));// 新增就业人员
			jgData.setValue("fYBTBMX_XMZT", row.val("fXMJZ_XMZT"));// 项目状态
			jgData.setValue("fYBTBMX_YQBS", "3");// 页签标识
		});
		// 实际完成投资
		filter = "YQHZ_XMJZ.fXMJZ_ND='"
				+ nd
				+ "' and YQHZ_XMJZ.fXMJZ_YD='"
				+ yd
				+ "' and YQHZ_XMJZ.fXMJZ_SZZZFID like '%"
				+ org + "%' and YQHZ_XMJZ.fXMJZ_SJTZYQ ='1'";
		xmjz.setFilter("filter", filter);
		xmjz.refreshData();
		// 循环赋值
		var sjwcData = this.comp("sjwcData");
		sjwcData.clear();// 赋值前清空data
		xmjz.each(function(param) {
			sjwcData.newData();// 新增行
			var row = param.row;
			sjwcData.setValue("fXMXX_XMMC", row.val("fXMXX_XMMC"));// 项目名称
			sjwcData.setValue("fYBTBMX_XMID", row.val("fXMJZ_XMID"));// 项目ID
			sjwcData.setValue("fYBTBMX_KGRQ", row.val("fXMJZ_KGRQ"));// 开工日期
			sjwcData.setValue("fXMXX_LSGX", row.val("LSGX"));// 隶属关系
			sjwcData.setValue("fXMXX_TZGM", row.val("fXMXX_TZGM"));// 投资规模
			sjwcData.setValue("fHZQY_QYMC", row.val("fXMXX_XMMC"));// 甲方
			sjwcData.setValue("fXMXX_YF1", row.val("fXMXX_YF1"));// 乙方
			sjwcData.setValue("fYBTBMX_DHXM", row.val("fXMJZ_DHXM"));// 大会项目
			sjwcData.setValue("fYBTBMX_GSZC", row.val("fXMJZ_GSZCDJQK"));// 工商注册
			sjwcData.setValue("fYBTBMX_ZCQYMC", row.val("fXMJZ_ZCQYMC"));// 注册企业
			sjwcData.setValue("fYBTBMX_XMJZ", row.val("fXMJZ_XMJZ"));// 项目进展
			sjwcData.setValue("fYBTBMX_XYXDDWT", row.val("fXMJZ_XYXDDWT"));// 需要协调的问题
			sjwcData.setValue("fYBTBMX_BYTZE", row.val("fXMJZ_BYWCTZ"));// 本月投资额
			sjwcData.setValue("fYBTBMX_JZSYLJWCE", row.val("fXMJZ_SYLJWCE"));// 截至上月累计完成
			sjwcData.setValue("fYBTBMX_JZMQLJWCE", row.val("fXMJZ_MQLJWCE"));// 截至目前累计完成
			sjwcData.setValue("fYBTBMX_XMZT", row.val("fXMJZ_XMZT"));// 项目状态
			sjwcData.setValue("fYBTBMX_YQBS", "1");// 页签标识
		});

	};

	// 提交 mengjie 20200106
	Model.prototype.submittonClick = function(event) {
		// 判断 只有自由态、初审退回可以提交
		var mainData = this.comp("mainData");
		var shzt = mainData.getValue("fYBTBZB_SHZT");
		if (shzt == "0" || shzt == "2") {
			mainData.setValue("fYBTBZB_SHZT", "1");
			this.xstate = "1";
			mainData.saveData();
			mainData.refreshData();
		} else {
			alert("只有自由态、初审驳回单据才能提交");
		}
		;
	};

	// 收回 mengjie 20200106
	Model.prototype.backtonClick = function(event) {
		// 判断 只有提交的才能收回
		var mainData = this.comp("mainData");
		var shzt = mainData.getValue("fYBTBZB_SHZT");
		if (shzt == "1") {
			mainData.setValue("fYBTBZB_SHZT", "0");
			this.xstate = "0";
			mainData.saveData();
			mainData.refreshData();
		} else {
			alert("只有提交单据才能收回");
		}

	};

	// 保存前 检查上级组织 mengjie
	Model.prototype.mainDataBeforeSave = function(event) {
		// 上级组织
		var sjdw = this.comp("sjdw");
		if (sjdw.count() != 1) {
			throw justep.Error.create("上级单位不存在,请联系系统管理员!");
		}
		event.source.setValue("fYBTBZB_SJDWID", sjdw.getValue("SFID"));
	};

	return Model;
});